<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['cai:payConfig:add']"
        >新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          plain
          icon="el-icon-edit"
          size="mini"
          :disabled="single"
          @click="handleUpdate"
          v-hasPermi="['cai:payConfig:edit']"
        >修改</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="payConfigList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="名称" align="center" prop="name" />
      <el-table-column label="支付方式" align="center" prop="payType" >
        <template v-slot="scope">
          <cai-dict-tag :options="payConfigTypeList" :value="scope.row.payType"/>
        </template>
      </el-table-column>
      <el-table-column label="支付宝AppId" align="center" prop="appid" />
      <el-table-column label="微信商户号" align="center" prop="wxMcid" />
      <el-table-column label="回调域名" align="center" prop="notifyUrl" show-overflow-tooltip/>
      <el-table-column label="开启状态" align="center" prop="enableStatus">
        <template v-slot="scope">
          <el-switch
              v-model="scope.row.enableStatus"
              :active-value="1"
              :inactive-value="0"
              @change="handleEnableStatusChange(scope.row)"
          ></el-switch>
        </template>
      </el-table-column>
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template v-slot="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['cai:payConfig:edit']"
          >修改</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['cai:payConfig:remove']"
          >删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <pay-config-add-or-update-dialog v-if="payConfigAddOrUpdateDialogVisible" ref="payConfigAddOrUpdateDialog" @refreshDataList="getList"/>
  </div>
</template>

<script>
import {delPayConfig, listPayConfig, updatePayConfig, updatePayConfigStatus} from "@/api/cai/payConfig";
import {payConfigTypeList} from "@/constant/statusMap";
import PayConfigAddOrUpdateDialog from "@/views/cai/payConfig/pay-config-add-or-update-dialog";

export default {
  name: "PayConfig",
  components: {
    PayConfigAddOrUpdateDialog
  },
  data() {
    return {
      payConfigTypeList,
      payConfigAddOrUpdateDialogVisible: false,
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 支付配置表格数据
      payConfigList: [],
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
      },
    };
  },
  created() {
    this.getList();
  },
  methods: {
    /** 查询支付配置列表 */
    getList() {
      this.loading = true;
      listPayConfig(this.queryParams).then(response => {
        this.payConfigList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.payConfigAddOrUpdateDialogVisible = true
      this.$nextTick(() => {
        this.$refs.payConfigAddOrUpdateDialog.init()
      })
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.payConfigAddOrUpdateDialogVisible = true
      this.$nextTick(() => {
        this.$refs.payConfigAddOrUpdateDialog.init(row.id)
      })
    },
    handleEnableStatusChange(row){
      let text = row.enableStatus === 0 ? '关闭' : '开启'
      this.$confirm('确认要' + text + '[' + row.name + ']的支付配置吗?', '警告', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        type: 'warning'
      }).then(() => {
        return updatePayConfigStatus({ id: row.id, enableStatus: row.enableStatus })
      }).then(() => {
        this.$modal.msgSuccess(text + '成功')
      }).catch(function() {
        row.enableStatus = row.enableStatus === 0 ? 1 : 0
      })
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      this.$modal.confirm('是否确认删除支付配置名称为"' + row.name + '"的数据项？').then(() => {
        this.loading = true;
        return delPayConfig(row.id);
      }).then(() => {
        this.loading = false;
        this.getList();
        this.$modal.msgSuccess("删除成功");
      }).catch(() => {
      }).finally(() => {
        this.loading = false;
      });
    },
  }
};
</script>
